/* =========================================================== */
/* EXmacro.h    ALU and shifter environments of the DLX        */
/* ----------------------------------------------------------- */
/*  last update: 9823nov SMM                                   */
/* =========================================================== */

#ifndef EXmacro_H
#define EXmacro_H

struct variable_parameters {
  int n;                        /* width of the data paths */
  int A;                        /* # GP-Registers */
  int S;                        /* # SP-Registers */
  int BUS;                      /* mbusy, off-chip, cache */
  int dbus;                     /* delay: memory bus */
  int dMhsh;                    /* delay: memory handshake */
  int dmem, dImem;              /* memory access time */
  int dstat, dIstat;            /* memory status time */
  int Mword;                    /* memory size in word */
};

extern struct variable_parameters var;

extern int cau(), dau(), dau2();   /* arith unit n, n=2 */ 
extern int ccomp(), dcomp();       /* comparator */
extern int calu(), dALU();         /* ALU */
extern int caluglue(), daluglue(); /* ALU glue */ 
extern int cALUenv(), dALUenv();   /* ALU environment */
extern int dALUe2(), dALUovf();    /* delay s[1:0], ovf */

extern int cshenv(), dshenv();     /* shifter SHenv */
extern int cSH4Le(), dSH4Le();     /* shifter SH4Lenv, no SPR */
extern int cSH4Lie(), dSH4Lie();   /* SH4Lenv, + interrupts */
extern int cSH4Lif(), dSH4Lif();   /* SH4Lenv, + SPR + FPU */

#endif EXmacro_H
