/***************************************************************
**  cache.h      cache interface                              **
** ---------------------------------------------------------- **
**  98/apr/06 smm                                             **
***************************************************************/
/* ---------------------------------------------------------- */
/*  Cost + Dealy:  Cache interface                            */
/*     sectored, k-way set-associative cache with forwarding  */
/* ---------------------------------------------------------- */

#ifndef CACHE_H
#define CACHE_H

extern int CchIF();          /* cost: cache interface */
extern int AchIF_hit();      /* acc. delay: cacheIF -> hit */
extern int AchIF_Dout();     /* acc. delay: cacheIF -> Dout */
extern int AchIf_MAdr();     /* acc. delay: cacheIF -> MAdr */
extern int TchIF();          /* cycle time of cacheIF */
extern int DchIFM_Dout();    /* delay: MDat -> Dout */
extern int DchIFM_ch();      /* delay: MDat -> cacheIF */


struct cache_parameters {
  int tag;                     /* width of tags */
  int line;                    /* number of lines */
  int sector;                  /* number of sectors/line */
  int boff;                    /* number bytes/sector */
  int way;                     /* set assoziativity */
  int wrpol;                   /* write policy:  0/1  */
			       /* write through/ back */
};

/* accumulated delay of the inputs of the cache interface */
struct cacheIF_inputs {
  int A, Din, csig;
};

extern struct cache_parameters cache;
extern struct cacheIF_inputs cacheIF;

#endif CACHE_H

