/***************************************************************
**  evaluate.h      quality ratio Q(q,A,B) and equal quality  **
**                  parameter EQ(A,B) of two designs A,B      **
**  950801 TGR 0.1                                            **
**  950811 SMM 0.2  (update of EQ(), degenerated cases)       **
***************************************************************/
/* q      : quality parameter q                               */
/* ca, ta : cost, dealy of A      cb, tb : cost, dealy of B   */
/* ---------------------------------------------------------- */
/* Let F be the faster and S be the slower of the designs.    */
/* EQ(S,F) defined for                                        */
/*   a) ts > tf  and  cs <= cf;   b) ts >= tf  and  cs < cf   */
/* Degenerated cases:                                         */
/*  ts = tf and cs = cf: always same quality:  EQ(S,F) := +2  */
/*  ts > tf and cs > cf: never same quality:   EQ(S,F) := -2  */
/* ---------------------------------------------------------- */

#ifndef EVALUATE_H
#define EVALUATE_H

extern double eval_Q();         /* q, ca, ta, cb, tb */
extern double eval_EQ();        /* ca, ta, cb, tb */

#endif

